
# variables
LOOPS_PER_SECOND = 200
TIME_TO_WAIT = 1 / LOOPS_PER_SECOND


# PIN
LED_PIN = 25
SERVO_PIN = 16  # ORANGE
MOTOR_PIN_RIGHT_FRONT = 3
MOTOR_PIN_RIGHT_BACK = 2
MOTOR_PIN_LEFT_FRONT = 4
MOTOR_PIN_LEFT_BACK = 5
U_SENSOR_PIN_TRIGGER = 26  # GREEN
U_SENSOR_PIN_ECHO = 27  # VIOLET

# SERVO
SERVO_STEP = 50000
SERVO_FREQ = 50
SCAN_CENTER = 1300000
SCAN_MAX_RIGHT = 900000
SCAN_MAX_LEFT = 1900000
N_SCAN_STEP_FULLSCAN = int((SCAN_MAX_LEFT-SCAN_MAX_RIGHT)/SERVO_STEP)
DIRECTION = 1

# THRESHOLDS
THRES_ALL_FREE = 50 # cm
THRES_OBSTACLE = 35  # cm
THRES_FULL_SCAN = 20  # cm
THRES_START = 3 # cm

# PWM MOTOR SPEEDS
PWM_MOTOR_FREQ = 500
PERIOD = 1 / PWM_MOTOR_FREQ * 1000000000
# THIS ARE REFERRED TO FREQ 500 -> PERIOD = 2ms = 2000us = 2000000ns

# CORREZIONE DELLA DIREZIONE: 1 means the robot is going straight, less/more than 1 means the robot is biased to the right/left,
DIR_CORRECTION = [0.8, 1] # PIU BASSO DIR_CORRECTION, PIU LENTA QUELLA RUOTA VA
ADAGIO = [int(PERIOD * 0.7 * DIR_CORRECTION[0]), int(PERIOD * 0.7 * DIR_CORRECTION[1])]  # 2/5 of the period (slower does not start sometimes)
ANDANTE = [int(PERIOD * 0.8 * DIR_CORRECTION[0]), int(PERIOD * 0.8 * DIR_CORRECTION[1])] # half of the period
MARCIA = [int(PERIOD * 0.9 * DIR_CORRECTION[0]), int(PERIOD * 0.9 * DIR_CORRECTION[1])] # 3/5 of the period
ALLEGRO = [int(PERIOD * 0.95 * DIR_CORRECTION[0]), int(PERIOD * 0.95 * DIR_CORRECTION[1])] # 3/4 of the period
PRESTO = [int(PERIOD * DIR_CORRECTION[0]), int(PERIOD * DIR_CORRECTION[1])] # full power
TURNING_TIME = 0.3
STOP = 0
GEARS = [STOP, ADAGIO, ANDANTE, MARCIA, ALLEGRO, PRESTO]

# ENOUGH TIME TO SPEED UP
ENOUGH_TO_CHANGE_GEAR = LOOPS_PER_SECOND/2
print("e", ENOUGH_TO_CHANGE_GEAR)
# GO CRAZY
DRIFT_COUNTER = 120*LOOPS_PER_SECOND

# FOR THE PINS
UP = 1
DOWN = 0
